
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ProductsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.create(
            {
                id: data.id || undefined,
        
        item_type: data.item_type
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        sku: data.sku
        ||
        null
            ,
            
        barcode: data.barcode
        ||
        null
            ,
            
        unit_name: data.unit_name
        ||
        null
            ,
            
        sales_price: data.sales_price
        ||
        null
            ,
            
        purchase_cost: data.purchase_cost
        ||
        null
            ,
            
        is_taxable: data.is_taxable
        ||
        false
        
            ,
            
        reorder_level: data.reorder_level
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await products.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await products.setTax_code( data.tax_code || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'product_images',
                belongsToId: products.id,
            },
            data.product_images,
            options,
        );
        

        return products;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const productsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                item_type: item.item_type
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                sku: item.sku
            ||
            null
            ,
            
                barcode: item.barcode
            ||
            null
            ,
            
                unit_name: item.unit_name
            ||
            null
            ,
            
                sales_price: item.sales_price
            ||
            null
            ,
            
                purchase_cost: item.purchase_cost
            ||
            null
            ,
            
                is_taxable: item.is_taxable
            ||
            false
        
            ,
            
                reorder_level: item.reorder_level
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const products = await db.products.bulkCreate(productsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < products.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.products.getTableName(),
                    belongsToColumn: 'product_images',
                    belongsToId: products[i].id,
                },
                data[i].product_images,
                options,
            );
        }
        

        return products;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const products = await db.products.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.item_type !== undefined) updatePayload.item_type = data.item_type;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.sku !== undefined) updatePayload.sku = data.sku;
        
        
        if (data.barcode !== undefined) updatePayload.barcode = data.barcode;
        
        
        if (data.unit_name !== undefined) updatePayload.unit_name = data.unit_name;
        
        
        if (data.sales_price !== undefined) updatePayload.sales_price = data.sales_price;
        
        
        if (data.purchase_cost !== undefined) updatePayload.purchase_cost = data.purchase_cost;
        
        
        if (data.is_taxable !== undefined) updatePayload.is_taxable = data.is_taxable;
        
        
        if (data.reorder_level !== undefined) updatePayload.reorder_level = data.reorder_level;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await products.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await products.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.tax_code !== undefined) {
            await products.setTax_code(
              
              data.tax_code,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'product_images',
                belongsToId: products.id,
            },
            data.product_images,
            options,
        );
        

        return products;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of products) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of products) {
                await record.destroy({transaction});
            }
        });


        return products;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findByPk(id, options);

        await products.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await products.destroy({
            transaction
        });

        return products;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findOne(
            { where },
            { transaction },
        );

        if (!products) {
            return products;
        }

        const output = products.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        output.inventory_items_product = await products.getInventory_items_product({
            transaction
        });
        
        
        
        output.quote_lines_product = await products.getQuote_lines_product({
            transaction
        });
        
        
        
        output.invoice_lines_product = await products.getInvoice_lines_product({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await products.getOrganization({
            transaction
        });
        
        
        output.tax_code = await products.getTax_code({
            transaction
        });
        
        
        output.product_images = await products.getProduct_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.tax_codes,
        as: 'tax_code',
        
        where: filter.tax_code ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tax_code.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tax_code.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'product_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.sku) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'sku',
                        filter.sku,
                    ),
                };
            }
            
            if (filter.barcode) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'barcode',
                        filter.barcode,
                    ),
                };
            }
            
            if (filter.unit_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'unit_name',
                        filter.unit_name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.sales_priceRange) {
                const [start, end] = filter.sales_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sales_price: {
                    ...where.sales_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sales_price: {
                    ...where.sales_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.purchase_costRange) {
                const [start, end] = filter.purchase_costRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    purchase_cost: {
                    ...where.purchase_cost,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    purchase_cost: {
                    ...where.purchase_cost,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reorder_levelRange) {
                const [start, end] = filter.reorder_levelRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reorder_level: {
                    ...where.reorder_level,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reorder_level: {
                    ...where.reorder_level,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.item_type) {
                where = {
                    ...where,
                item_type: filter.item_type,
            };
            }
            
            if (filter.is_taxable) {
                where = {
                    ...where,
                is_taxable: filter.is_taxable,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.products.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'products',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.products.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

